<?xml version="1.0" encoding="utf-8"?>
<!-- gxml-to-xml:  read XML document containing some 'generic XML'
     (elements named element, attribute, and so on), write the
     equivalent document in conventional XML.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                version="3.0"
                default-mode="gxml"
>

  <xsl:mode name="gxml" on-no-match="shallow-copy"/>
  
  <xsl:output
      indent="no"
      />

  <!--****************************************************************
      * Elements
      ****************************************************************
      *-->
  <xsl:template match="__ELEMENT">
    <xsl:element name="{@__GI}">
      <xsl:apply-templates/>
    </xsl:element>    
  </xsl:template>

  <!--****************************************************************
      * Attibutes
      ****************************************************************
      *-->
  <xsl:template match="__ATTRIBUTE">
    <xsl:attribute name="{@__NAME}"
                   select="@__VALUE"/>
  </xsl:template>

  <!--****************************************************************
      * PCDATA
      ****************************************************************
      *-->
  <xsl:template match="__PCDATA">
    <xsl:sequence select="string()"/>
  </xsl:template>

  <!--****************************************************************
      * Comments
      ****************************************************************
      *-->
  <xsl:template match="__COMMENT">
    <xsl:comment>
      <xsl:sequence select="string(__COMMENT-DATA)"/>
    </xsl:comment>
  </xsl:template>
  
</xsl:stylesheet>
